import sys
from pathlib import Path

from metadocker.cmdline.commands.base import Argument, Command
from metadocker.db.db import settings

class InitCommand(Command):
    NAME = "init"
    HELP = "Initialise un script"
    ARGUMENTS = [
        Argument("env", help="Le type d'environnement à initialiser"),
        Argument("name", help="Le nom du metadocekr"),
        Argument("--values", "-v", nargs="*", help="Les valeurs à remplir de la forme: KEY= KEY2=ARG")
    ]

    def run(self):

        values = {"PROJECT" : self.name}
        for value in (self.values or []):
            if "=" in value:
                key, _, value = value.partition("=")
            else:
                key=value
                value=""
            values[key] = value


        settings.app_docker_cache.create(self.env.lower(), self.name, values)