

class MetadockerError(Exception):

    def get_error(self):
        raise NotImplementedError()

    def __repr__(self):
        return self.get_error()

class SimpleError(MetadockerError):
    def __init__(self, err):
        super().__init__(err)
        self._err = err

    def get_error(self):
        return repr(self._err)


class MultipleError(MetadockerError):

    def __init__(self, errors):
        super().__init__(errors)
        self._errors = errors

    def get_error(self):
        return "\n".join([x.get_error() for x in self._errors])