import shutil

from metadocker.common.errors import SimpleError
from metadocker.db.db import DockerManagerBase, settings
from metadocker.db.entry import DockerEntry



class DockerManager(DockerManagerBase):

    def __init__(self):
        self.dockers : dict[str,DockerEntry] = {}


    def save(self):
        settings.save()

    def refresh(self):
        for v in self.dockers.values():
            v.refresh()

    def remove(self, name, remove_files=True):
        docker = self.get(name)
        if remove_files:
            docker.remove()
        self.dockers.pop(name)
        self.save()


    def get(self, name):
        if name not in self.dockers:
            raise SimpleError(f"Impossible de trouver le conteneur {name} dans metadocker")
        return self.dockers[name]


    def create(self, env_name, name, values):
        if name in self.dockers:
            raise SimpleError(f"Le docker {name} existe déja. Abandon")
        docker = DockerEntry(name)
        docker.create(env_name, values)
        self.dockers[name] = docker
        self.save()




